'use strict';

exports.__esModule = true;

var _errorOverlayMiddleware = require('react-dev-utils/errorOverlayMiddleware');

var _errorOverlayMiddleware2 = _interopRequireDefault(_errorOverlayMiddleware);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class ErrorOverlayPlugin {
  apply(compiler) {
    if (compiler.options.mode !== 'development') return;

    compiler.hooks.entryOption.tap('TestPlugin', (context, entry) => {
      entry.unshift(require.resolve('./entry'));
    });

    compiler.hooks.afterResolvers.tap('TestPlugin', ({ options }) => {
      if (options.devServer) {
        const originalBefore = options.devServer.before;
        options.devServer.before = app => {
          if (originalBefore) {
            originalBefore(app);
          }
          app.use((0, _errorOverlayMiddleware2.default)());
        };
      }
    });
  }
}

exports.default = ErrorOverlayPlugin;